﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Telerik.Core.Data;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace App5
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private int currentCount = 0;
        private IncrementalLoadingCollection<Data> data;

        public MainPage()
        {
            this.InitializeComponent();

            this.data = new IncrementalLoadingCollection<Data>(this.GetMoreItems) { BatchSize = 60 };

            this.data.LoadMoreItemsAsync(60);

            this.DataContext = data;
        }

     private async Task<IEnumerable<Data>> GetMoreItems(uint count)
    {
        await Task.Delay(1000);
        var result = Enumerable.Range(this.currentCount, (int)count).Select(x => new Data { Name = "item " + x, ID = x }).ToList();
        currentCount += (int)count;
        return result;
    }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            list.ScrollItemIntoView(data[40]);
        }
    }

    public class Data
    {
        public int ID { get; set; }

        public string Name { get; set; }
    }
}
